Index: src/org/jboss/tools/deltacloud/ui/views/DeltaCloudImageColumns.java
===================================================================
--- src/org/jboss/tools/deltacloud/ui/views/DeltaCloudImageColumns.java	(revision 29180)
+++ src/org/jboss/tools/deltacloud/ui/views/DeltaCloudImageColumns.java	(working copy)
@@ -12,33 +12,36 @@
 
 import org.jboss.tools.deltacloud.core.DeltaCloudImage;
 
+/**
+ * @author André Dietisheim
+ */
 public class DeltaCloudImageColumns extends Columns<DeltaCloudImage> {
 
 	@SuppressWarnings("unchecked")
 	public DeltaCloudImageColumns() {
 		super(
-				new Column<DeltaCloudImage>("NAME", 20) {
+				new Column<DeltaCloudImage>("DeltaCloudElementColumn.name.label", 20) {
 
 					@Override
 					public String getColumnText(DeltaCloudImage image) {
 						return image.getName();
 					}
 				},
-				new Column<DeltaCloudImage>("ID", 20) {
+				new Column<DeltaCloudImage>("DeltaCloudElementColumn.id.label", 20) {
 
 					@Override
 					public String getColumnText(DeltaCloudImage image) {
 						return image.getId();
 					}
 				},
-				new Column<DeltaCloudImage>("ARCH", 20) {
+				new Column<DeltaCloudImage>("DeltaCloudElementColumn.architecture.label", 20) {
 
 					@Override
 					public String getColumnText(DeltaCloudImage image) {
 						return image.getArchitecture();
 					}
 				},
-				new Column<DeltaCloudImage>("DESC", 40) {
+				new Column<DeltaCloudImage>("DeltaCloudElementColumn.description.label", 40) {
 					@Override
 					public String getColumnText(DeltaCloudImage image) {
 						return image.getDescription();
Index: src/org/jboss/tools/internal/deltacloud/ui/wizards/AbstractDeltaCloudWizard.java
===================================================================
--- src/org/jboss/tools/internal/deltacloud/ui/wizards/AbstractDeltaCloudWizard.java	(revision 0)
+++ src/org/jboss/tools/internal/deltacloud/ui/wizards/AbstractDeltaCloudWizard.java	(revision 0)
@@ -0,0 +1,30 @@
+/*******************************************************************************
+ * Copyright (c) 2010 Red Hat, Inc.
+ * Distributed under license by Red Hat, Inc. All rights reserved.
+ * This program is made available under the terms of the
+ * Eclipse Public License v1.0 which accompanies this distribution,
+ * and is available at http://www.eclipse.org/legal/epl-v10.html
+ *
+ * Contributors:
+ *     Red Hat, Inc. - initial API and implementation
+ ******************************************************************************/
+package org.jboss.tools.internal.deltacloud.ui.wizards;
+
+import org.eclipse.jface.wizard.Wizard;
+import org.jboss.tools.deltacloud.core.DeltaCloud;
+
+/**
+ * @author André Dietisheim
+ */
+public abstract class AbstractDeltaCloudWizard extends Wizard {
+
+	private DeltaCloud cloud;
+
+	public AbstractDeltaCloudWizard(DeltaCloud cloud) {
+		this.cloud = cloud;
+	}
+	
+	protected DeltaCloud getDeltaCloud() {
+		return cloud;
+	}
+}
Index: src/org/jboss/tools/deltacloud/ui/commands/FilterInstancesHandler.java
===================================================================
--- src/org/jboss/tools/deltacloud/ui/commands/FilterInstancesHandler.java	(revision 29180)
+++ src/org/jboss/tools/deltacloud/ui/commands/FilterInstancesHandler.java	(working copy)
@@ -17,13 +17,12 @@
 import org.eclipse.core.runtime.Status;
 import org.eclipse.jface.viewers.ISelection;
 import org.eclipse.jface.viewers.IStructuredSelection;
-import org.eclipse.jface.wizard.IWizard;
-import org.eclipse.jface.wizard.WizardDialog;
 import org.eclipse.swt.widgets.Display;
 import org.eclipse.swt.widgets.Shell;
 import org.eclipse.ui.handlers.HandlerUtil;
 import org.jboss.tools.deltacloud.core.DeltaCloud;
-import org.jboss.tools.internal.deltacloud.ui.utils.UIUtils;
+import org.jboss.tools.internal.deltacloud.ui.utils.WizardUtils;
+import org.jboss.tools.internal.deltacloud.ui.utils.WorkbenchUtils;
 import org.jboss.tools.internal.deltacloud.ui.wizards.InstanceFilterWizard;
 
 /**
@@ -35,7 +34,7 @@
 	public Object execute(ExecutionEvent event) throws ExecutionException {
 		ISelection selection = HandlerUtil.getCurrentSelection(event);
 		if (selection instanceof IStructuredSelection) {
-			DeltaCloud deltaCloud = UIUtils.getFirstAdaptedElement(selection, DeltaCloud.class);
+			DeltaCloud deltaCloud = WorkbenchUtils.getFirstAdaptedElement(selection, DeltaCloud.class);
 			createInstancesFilter(deltaCloud, HandlerUtil.getActiveShell(event));
 		}
 
@@ -48,10 +47,7 @@
 
 				@Override
 				public void run() {
-					IWizard wizard = new InstanceFilterWizard(cloud);
-					WizardDialog dialog = new WizardDialog(shell, wizard);
-					dialog.create();
-					dialog.open();
+					WizardUtils.openWizardDialog(new InstanceFilterWizard(cloud), shell);
 				}
 			});
 		}
Index: src/org/jboss/tools/deltacloud/ui/commands/DeltaCloudPropertyTester.java
===================================================================
--- src/org/jboss/tools/deltacloud/ui/commands/DeltaCloudPropertyTester.java	(revision 29180)
+++ src/org/jboss/tools/deltacloud/ui/commands/DeltaCloudPropertyTester.java	(working copy)
@@ -15,7 +15,7 @@
 import org.jboss.tools.deltacloud.core.DeltaCloud;
 import org.jboss.tools.deltacloud.core.DeltaCloudException;
 import org.jboss.tools.deltacloud.core.DeltaCloudImage;
-import org.jboss.tools.internal.deltacloud.ui.utils.UIUtils;
+import org.jboss.tools.internal.deltacloud.ui.utils.WorkbenchUtils;
 
 /**
  * A property tester for the command framework that answers if the given
@@ -30,7 +30,7 @@
 
 	@Override
 	public boolean test(Object receiver, String property, Object[] args, Object expectedValue) {
-		DeltaCloud cloud = UIUtils.adapt(receiver, DeltaCloud.class);
+		DeltaCloud cloud = WorkbenchUtils.adapt(receiver, DeltaCloud.class);
 		if (cloud == null) {
 			return false;
 		}
Index: src/org/jboss/tools/internal/deltacloud/ui/wizards/NewInstancePageModel.java
===================================================================
--- src/org/jboss/tools/internal/deltacloud/ui/wizards/NewInstancePageModel.java	(revision 29180)
+++ src/org/jboss/tools/internal/deltacloud/ui/wizards/NewInstancePageModel.java	(working copy)
@@ -14,6 +14,7 @@
 import java.util.Collection;
 import java.util.List;
 
+import org.jboss.tools.deltacloud.core.DeltaCloud;
 import org.jboss.tools.deltacloud.core.DeltaCloudHardwareProfile;
 import org.jboss.tools.deltacloud.core.DeltaCloudImage;
 import org.jboss.tools.deltacloud.core.DeltaCloudRealm;
@@ -49,8 +50,10 @@
 	private String cpu;
 	private String storage;
 	private String memory;
+	private DeltaCloud cloud;
 
-	protected NewInstancePageModel(String keyId, DeltaCloudImage image) {
+	protected NewInstancePageModel(String keyId, DeltaCloudImage image, DeltaCloud cloud) {
+		this.cloud = cloud;
 		this.keyId = keyId;
 		this.image = image;
 	}
@@ -74,6 +77,10 @@
 		setArch(image.getArchitecture());
 	}
 
+	public int getSelectedRealmIndex() {
+		return realms.indexOf(selectedRealm);
+	}
+
 	public void setSelectedRealmIndex(int index) {
 		if (realms.size() > index) {
 			int oldIndex = -1;
@@ -82,17 +89,34 @@
 				oldIndex = realms.indexOf(selectedRealm);
 			}
 			DeltaCloudRealm deltaCloudRealm = realms.get(index);
-			setSelectedRealm(deltaCloudRealm);
+			selectedRealm = deltaCloudRealm;
+			cloud.setLastRealmName(selectedRealm.getName());
 			firePropertyChange(PROPERTY_SELECTED_REALM_INDEX, oldIndex, index);
 		}
 	}
 
-	public int getSelectedRealmIndex() {
-		return realms.indexOf(selectedRealm);
+	private void setSelectedRealm(String name) {
+		if (realms.size() > 0) {
+			int index = getRealmIndex(name);
+			if (index >= 0) {
+				setSelectedRealmIndex(index);
+			}
+		}
 	}
 
-	public void setSelectedRealm(DeltaCloudRealm realm) {
-		selectedRealm = realm;
+	private int getRealmIndex(String name) {
+		int index = 0;
+		if (name != null
+				&& realms != null
+				&& realms.size() > 0) {
+			for (int i = 0; i < realms.size(); i++) {
+				if (name.equals(realms.get(i).getName())) {
+					index = i;
+					break;
+				}
+			}
+		}
+		return index;
 	}
 
 	public String getRealmId() {
@@ -104,14 +128,14 @@
 
 	protected void setRealms(List<DeltaCloudRealm> realms) {
 		firePropertyChange(PROPERTY_REALMS, this.realms, this.realms = realms);
-		setSelectedRealmIndex(0);
+		setSelectedRealm(cloud.getLastRealmName());
 	}
 
 	public List<DeltaCloudRealm> getRealms() {
 		return realms;
 	}
 
-	protected void setAllProfiles(List<DeltaCloudHardwareProfile> profiles) {
+	public void setAllProfiles(List<DeltaCloudHardwareProfile> profiles) {
 		firePropertyChange(PROP_ALL_PROFILES, this.allProfiles, this.allProfiles = profiles);
 		setFilteredProfiles(filterProfiles(image, profiles));
 	}
@@ -122,7 +146,7 @@
 
 	private void setFilteredProfiles(List<DeltaCloudHardwareProfile> profiles) {
 		firePropertyChange(PROP_FILTERED_PROFILES, this.filteredProfiles, this.filteredProfiles = profiles);
-		setSelectedProfileIndex(0);
+		setSelectedProfileIndex();
 	}
 
 	public List<DeltaCloudHardwareProfile> getFilteredProfiles() {
@@ -143,6 +167,24 @@
 		return filteredProfiles;
 	}
 
+	private void setSelectedProfileIndex() {
+		setSelectedProfileIndex(getProfileIndex(cloud.getLastProfileId()));
+	}
+
+	private int getProfileIndex(String selectedProfileId) {
+		int index = 0;
+		if (selectedProfileId != null 
+				&& filteredProfiles != null && filteredProfiles.size() > 0) {
+			for (int i = 0; i < filteredProfiles.size(); i++) {
+				if (selectedProfileId.equals(filteredProfiles.get(i).getId())) {
+					index = i;
+					break;
+				}
+			}
+		}
+		return index;
+	}
+
 	public void setSelectedProfileIndex(int index) {
 		if (filteredProfiles.size() > index) {
 			int oldIndex = -1;
@@ -151,8 +193,9 @@
 				oldIndex = filteredProfiles.indexOf(selectedProfile);
 			}
 			DeltaCloudHardwareProfile hardwareProfile = filteredProfiles.get(index);
-			setSelectedProfile(hardwareProfile);
+			selectedProfile = hardwareProfile;
 			firePropertyChange(PROP_SELECTED_PROFILE_INDEX, oldIndex, index);
+			cloud.setLastProfileId(hardwareProfile.getId());
 		}
 	}
 
@@ -164,10 +207,6 @@
 		return filteredProfiles.indexOf(selectedProfile);
 	}
 
-	public void setSelectedProfile(DeltaCloudHardwareProfile profile) {
-		selectedProfile = profile;
-	}
-
 	public String getProfileId() {
 		if (selectedProfile == null) {
 			return null;
Index: schema/newInstanceWizardPage.exsd
===================================================================
--- schema/newInstanceWizardPage.exsd	(revision 29180)
+++ schema/newInstanceWizardPage.exsd	(working copy)
@@ -64,7 +64,7 @@
                   
                </documentation>
                <appinfo>
-                  <meta.attribute kind="java" basedOn=":org.jboss.tools.deltacloud.ui.INewInstanceWizardPage"/>
+                  <meta.attribute kind="java" basedOn=":org.jboss.tools.deltacloud.ui.wizard.INewInstanceWizardPage"/>
                </appinfo>
             </annotation>
          </attribute>
Index: src/org/jboss/tools/deltacloud/ui/wizard/INewInstanceWizardPage.java
===================================================================
--- src/org/jboss/tools/deltacloud/ui/wizard/INewInstanceWizardPage.java	(revision 29180)
+++ src/org/jboss/tools/deltacloud/ui/wizard/INewInstanceWizardPage.java	(working copy)
@@ -21,5 +21,5 @@
 
 	public static final String NEW_INSTANCE_FAMILY = "newInstanceFamily";
 
-	public ChainedJob getPerformFinishJob(DeltaCloudInstance addedInstance);
+	public ChainedJob createPerformFinishJob(DeltaCloudInstance addedInstance);
 }
Index: src/org/jboss/tools/internal/deltacloud/ui/wizards/CloudConnectionPageModel.java
===================================================================
--- src/org/jboss/tools/internal/deltacloud/ui/wizards/CloudConnectionPageModel.java	(revision 29180)
+++ src/org/jboss/tools/internal/deltacloud/ui/wizards/CloudConnectionPageModel.java	(working copy)
@@ -12,7 +12,7 @@
 
 import java.net.MalformedURLException;
 
-import org.jboss.tools.deltacloud.core.Driver;
+import org.jboss.tools.deltacloud.core.DeltaCloudDriver;
 import org.jboss.tools.internal.deltacloud.core.observable.ObservablePojo;
 
 /**
@@ -35,18 +35,18 @@
 	private String username;
 
 	private String password;
-	private Driver driver;
+	private DeltaCloudDriver driver;
 	private String initialName;
 
 	public CloudConnectionPageModel() {
-		this("", "", "", "", Driver.UNKNOWN);
+		this("", "", "", "", DeltaCloudDriver.UNKNOWN);
 	}
 
 	public CloudConnectionPageModel(String name, String url, String username, String password) throws MalformedURLException {
-		this(name, url, username, password, Driver.UNKNOWN);
+		this(name, url, username, password, DeltaCloudDriver.UNKNOWN);
 	}
 
-	public CloudConnectionPageModel(String name, String url, String username, String password, Driver driver) {
+	public CloudConnectionPageModel(String name, String url, String username, String password, DeltaCloudDriver driver) {
 		this.name = name;
 		this.initialName = name;
 			this.url = url;
@@ -91,11 +91,11 @@
 		firePropertyChange(PROPERTY_URL, this.url, this.url = url);
 	}
 
-	public Driver getDriver() {
+	public DeltaCloudDriver getDriver() {
 		return driver;
 	}
 
-	public void setDriver(Driver driver) {
+	public void setDriver(DeltaCloudDriver driver) {
 		firePropertyChange(PROPERTY_DRIVER, this.driver, this.driver = driver);
 	}
 }
Index: src/org/jboss/tools/deltacloud/ui/views/cloud/NumericFoldingItem.java
===================================================================
--- src/org/jboss/tools/deltacloud/ui/views/cloud/NumericFoldingItem.java	(revision 29180)
+++ src/org/jboss/tools/deltacloud/ui/views/cloud/NumericFoldingItem.java	(working copy)
@@ -19,7 +19,7 @@
  */
 public class NumericFoldingItem extends DeltaCloudViewItem<Object> {
 
-	public static int FOLDING_SIZE = 50;
+	public static final int FOLDING_SIZE = 50;
 	private Object min;
 	private int max;
 
Index: src/org/jboss/tools/internal/deltacloud/ui/utils/WorkbenchUtils.java
===================================================================
--- src/org/jboss/tools/internal/deltacloud/ui/utils/WorkbenchUtils.java	(revision 0)
+++ src/org/jboss/tools/internal/deltacloud/ui/utils/WorkbenchUtils.java	(revision 0)
@@ -0,0 +1,337 @@
+/*******************************************************************************
+ * Copyright (c) 2010 Red Hat, Inc.
+ * Distributed under license by Red Hat, Inc. All rights reserved.
+ * This program is made available under the terms of the
+ * Eclipse Public License v1.0 which accompanies this distribution,
+ * and is available at http://www.eclipse.org/legal/epl-v10.html
+ *
+ * Contributors:
+ *     Red Hat, Inc. - initial API and implementation
+ ******************************************************************************/
+package org.jboss.tools.internal.deltacloud.ui.utils;
+
+import java.util.ArrayList;
+import java.util.Collection;
+import java.util.List;
+
+import org.eclipse.core.runtime.Assert;
+import org.eclipse.core.runtime.IAdaptable;
+import org.eclipse.core.runtime.Platform;
+import org.eclipse.jface.action.ContributionManager;
+import org.eclipse.jface.action.GroupMarker;
+import org.eclipse.jface.action.IContributionManager;
+import org.eclipse.jface.action.IMenuManager;
+import org.eclipse.jface.action.MenuManager;
+import org.eclipse.jface.dialogs.IDialogSettings;
+import org.eclipse.jface.resource.ImageDescriptor;
+import org.eclipse.jface.resource.JFaceResources;
+import org.eclipse.jface.viewers.ISelection;
+import org.eclipse.jface.viewers.IStructuredSelection;
+import org.eclipse.swt.events.DisposeEvent;
+import org.eclipse.swt.events.DisposeListener;
+import org.eclipse.swt.widgets.Control;
+import org.eclipse.swt.widgets.Menu;
+import org.eclipse.swt.widgets.Shell;
+import org.eclipse.ui.IEditorPart;
+import org.eclipse.ui.IWorkbench;
+import org.eclipse.ui.IWorkbenchActionConstants;
+import org.eclipse.ui.IWorkbenchPage;
+import org.eclipse.ui.IWorkbenchPartSite;
+import org.eclipse.ui.IWorkbenchWindow;
+import org.eclipse.ui.PartInitException;
+import org.eclipse.ui.PlatformUI;
+import org.eclipse.ui.menus.IMenuService;
+import org.eclipse.ui.part.EditorPart;
+import org.eclipse.ui.plugin.AbstractUIPlugin;
+
+/**
+ * @author Andre Dietisheim
+ */
+public class WorkbenchUtils {
+
+	private static final String CONTEXT_MENU_PREFIX = "popup:";
+	private static final String VIEW_MENU_PREFIX = "menu:";
+
+	private WorkbenchUtils() {
+	}
+
+	/**
+	 * Returns the selection of the active workbench window.
+	 * 
+	 * @return the selection
+	 * 
+	 * @see IWorkbenchWindow#getSelectionService()
+	 */
+	public static ISelection getWorkbenchWindowSelection() {
+		return getActiveWorkbenchWindow().getSelectionService().getSelection();
+	}
+
+	/**
+	 * Gets the structured selection.
+	 * 
+	 * @return the structured selection
+	 */
+	public static IStructuredSelection getStructuredSelection() {
+		ISelection selection = getWorkbenchWindowSelection();
+		if (selection instanceof IStructuredSelection) {
+			return (IStructuredSelection) selection;
+		} else {
+			return null;
+		}
+	}
+
+	/**
+	 * Gets the first element of a given selection in the given type. Returns
+	 * <code>null</null> if selection is selection is empty or adaption of the first element in 
+	 * the given selection fails. Adaption is tried by casting and by adapting it.
+	 * 
+	 * @param selection
+	 *            the selection
+	 * @param expectedClass
+	 *            the expected class
+	 * 
+	 * @return the first element
+	 */
+	public static <T> T getFirstAdaptedElement(final ISelection selection, final Class<T> expectedClass) {
+		if (selection == null
+				|| !(selection instanceof IStructuredSelection)) {
+			return null;
+		} else {
+			Object firstElement = ((IStructuredSelection) selection).getFirstElement();
+			if (firstElement == null) {
+				return null;
+			}
+			return adapt(firstElement, expectedClass);
+		}
+	}
+
+	/**
+	 * Returns <code>true</code> if the given selection holds exactly 1 element
+	 * of the given type.
+	 * 
+	 * @param selection
+	 *            the selection to check
+	 * @param expectedClass
+	 *            the expected class
+	 * @return <code>true</code>, if the given selection holds a single element
+	 *         of the given type.
+	 */
+	public static <T> boolean isSingleSelection(final ISelection selection, final Class<T> expectedClass) {
+		if (!(selection instanceof IStructuredSelection)) {
+			return false;
+		}
+
+		return ((IStructuredSelection) selection).toList().size() == 1
+				&& getFirstAdaptedElement(selection, expectedClass) != null;
+	}
+
+	public static <T> List<T> adapt(Collection<?> objects, Class<T> expectedClass) {
+		List<T> adaptedObjects = new ArrayList<T>();
+		for (Object object : objects) {
+			T adaptedObject = adapt(object, expectedClass);
+			if (adaptedObject != null) {
+				adaptedObjects.add(adaptedObject);
+			}
+		}
+		return adaptedObjects;
+	}
+
+	/**
+	 * Adapts the given object to the given type. Returns <code>null</code> if
+	 * the given adaption is not possible. Adaption is tried by casting and by
+	 * adapting it.
+	 * 
+	 * @param <T>
+	 * @param object
+	 * @param expectedClass
+	 * @return
+	 */
+	@SuppressWarnings("unchecked")
+	public static <T> T adapt(Object object, Class<T> expectedClass) {
+		if (object == null) {
+			return null;
+		}
+
+		Object adaptedObject = null;
+		if (expectedClass.isAssignableFrom(object.getClass())) {
+			adaptedObject = object;
+		} else if (object instanceof IAdaptable) {
+			adaptedObject = ((IAdaptable) object).getAdapter(expectedClass);
+		}
+
+		if (adaptedObject != null) {
+			return (T) adaptedObject;
+		} else {
+			return (T) Platform.getAdapterManager().loadAdapter(object, expectedClass.getName());
+		}
+	}
+
+	/**
+	 * Gets the active page.
+	 * 
+	 * @return the active page
+	 */
+	public static IWorkbenchPage getActivePage() {
+		IWorkbenchPage workbenchPage = getActiveWorkbenchWindow().getActivePage();
+		Assert.isNotNull(workbenchPage);
+		return workbenchPage;
+	}
+
+	/**
+	 * Returns the editor that's currently active (focused).
+	 * 
+	 * @return the active editor
+	 */
+	public static IEditorPart getActiveEditor() {
+		IEditorPart editor = getActivePage().getActiveEditor();
+		Assert.isNotNull(editor);
+		return editor;
+	}
+
+	/**
+	 * Gets the active workbench window.
+	 * 
+	 * @return the active workbench window
+	 */
+	public static IWorkbenchWindow getActiveWorkbenchWindow() {
+		IWorkbenchWindow workbenchWindow = getWorkbench().getActiveWorkbenchWindow();
+		Assert.isNotNull(workbenchWindow);
+		return workbenchWindow;
+	}
+
+	public static Shell getActiveShell() {
+		Shell shell = getActiveWorkbenchWindow().getShell();
+		Assert.isTrue(shell != null && !shell.isDisposed());
+		return shell;
+	}
+
+	/**
+	 * Gets the workbench.
+	 * 
+	 * @return the workbench
+	 */
+	public static IWorkbench getWorkbench() {
+		IWorkbench workbench = PlatformUI.getWorkbench();
+		Assert.isNotNull(workbench);
+		return workbench;
+	}
+
+	/**
+	 * Replaces an image with the given key by the given image descriptor.
+	 * 
+	 * @param imageKey
+	 *            the image key
+	 * @param imageDescriptor
+	 *            the image descriptor
+	 */
+	public static void replaceInJfaceImageRegistry(final String imageKey, final ImageDescriptor imageDescriptor) {
+		Assert.isNotNull(imageKey);
+		Assert.isNotNull(imageDescriptor);
+
+		JFaceResources.getImageRegistry().remove(imageKey);
+		JFaceResources.getImageRegistry().put(imageKey, imageDescriptor);
+	}
+
+	/**
+	 * Register the given ContributionManager with the given id. The
+	 * contribution manager gets unregistered on control disposal.
+	 * 
+	 * @param id
+	 *            the id
+	 * @param contributionManager
+	 *            the contribution manager
+	 * @param control
+	 *            the control
+	 * 
+	 * @see ContributionManager
+	 * @see IMenuService
+	 * @see DisposeListener
+	 */
+	public static void registerContributionManager(final String id, final IContributionManager contributionManager,
+			final Control control) {
+		Assert.isNotNull(id);
+		Assert.isNotNull(contributionManager);
+		Assert.isTrue(control != null && !control.isDisposed());
+
+		final IMenuService menuService = (IMenuService) PlatformUI.getWorkbench().getService(IMenuService.class);
+		menuService.populateContributionManager((ContributionManager) contributionManager, id);
+		contributionManager.update(true);
+		control.addDisposeListener(new DisposeListener()
+		{
+			public void widgetDisposed(DisposeEvent e)
+			{
+				menuService.releaseContributions((ContributionManager) contributionManager);
+			}
+		});
+	}
+
+	public static String getContextMenuId(String viewId) {
+		return new StringBuffer(CONTEXT_MENU_PREFIX).append(viewId).toString();
+	}
+
+	public static String getViewMenuId(String viewId) {
+		return new StringBuffer(VIEW_MENU_PREFIX).append(viewId).toString();
+	}
+
+	/**
+	 * Creates context menu to a given control.
+	 * 
+	 * @param control
+	 *            the control
+	 * 
+	 * @return the i menu manager
+	 */
+	public static IMenuManager createContextMenu(final Control control) {
+		Assert.isTrue(control != null && !control.isDisposed());
+
+		MenuManager menuManager = new MenuManager();
+		menuManager.add(new GroupMarker(IWorkbenchActionConstants.MB_ADDITIONS));
+
+		Menu menu = menuManager.createContextMenu(control);
+		control.setMenu(menu);
+		return menuManager;
+	}
+
+	/**
+	 * Gets the dialog settings for the given identifer and plugin.
+	 * 
+	 * @param identifier
+	 *            the identifier
+	 * @param plugin
+	 *            the plugin
+	 * 
+	 * @return the dialog settings
+	 */
+	public static IDialogSettings getDialogSettings(final String identifier, final AbstractUIPlugin plugin) {
+		Assert.isNotNull(plugin);
+		IDialogSettings dialogSettings = plugin.getDialogSettings();
+		IDialogSettings section = dialogSettings.getSection(identifier);
+		if (section == null) {
+			section = dialogSettings.addNewSection(identifier);
+		}
+		return section;
+	}
+
+	/**
+	 * Returns the page for a given editor.
+	 * 
+	 * @param editor
+	 *            the editor
+	 * @return
+	 * 
+	 * @return the page
+	 * 
+	 * @see IWorkbenchPage
+	 */
+	public static IWorkbenchPage getPage(EditorPart editor) {
+		Assert.isNotNull(editor);
+		IWorkbenchPartSite site = editor.getSite();
+		Assert.isNotNull(site);
+		return site.getPage();
+	}
+
+	public static void showView(String viewId) throws PartInitException {
+		Assert.isLegal(viewId != null && viewId.length() > 0);
+		getActivePage().showView(viewId);
+	}
+}
Index: src/org/jboss/tools/deltacloud/ui/views/cloudelements/InstanceView.java
===================================================================
--- src/org/jboss/tools/deltacloud/ui/views/cloudelements/InstanceView.java	(revision 29180)
+++ src/org/jboss/tools/deltacloud/ui/views/cloudelements/InstanceView.java	(working copy)
@@ -10,10 +10,13 @@
  *******************************************************************************/
 package org.jboss.tools.deltacloud.ui.views.cloudelements;
 
+import java.beans.PropertyChangeEvent;
+
 import org.eclipse.ui.PlatformUI;
 import org.eclipse.ui.services.IEvaluationService;
 import org.jboss.tools.deltacloud.core.DeltaCloud;
 import org.jboss.tools.deltacloud.core.DeltaCloudInstance;
+import org.jboss.tools.deltacloud.core.ICloudElementFilter;
 import org.jboss.tools.deltacloud.ui.IDeltaCloudPreferenceConstants;
 
 /**
@@ -27,7 +30,7 @@
 public class InstanceView extends AbstractCloudElementTableView<DeltaCloudInstance> {
 
 	protected String getSelectedCloudPrefsKey() {
-		return IDeltaCloudPreferenceConstants.LAST_CLOUD_INSTANCE_VIEW;
+		return IDeltaCloudPreferenceConstants.CLOUD_LAST_INSTANCE_KEY;
 	}
 
 	@Override
@@ -51,10 +54,24 @@
 	}
 
 	@Override
+	public void propertyChange(PropertyChangeEvent event) {
+		super.propertyChange(event);
+		if (DeltaCloud.PROP_INSTANCES.equals(event.getPropertyName())) {
+			updateFilteredLabel();
+		}
+	}
+
+	@Override
 	protected void addPropertyChangeListener(DeltaCloud cloud) {
 		if (cloud != null) {
 			super.addPropertyChangeListener(cloud);
 			cloud.addPropertyChangeListener(DeltaCloud.PROP_INSTANCES, this);
 		}
 	}
+
+	@Override
+	protected ICloudElementFilter<DeltaCloudInstance> getFilter(DeltaCloud cloud) {
+		return cloud.getInstanceFilter();
+	}
+
 }
Index: src/org/jboss/tools/deltacloud/ui/adapter/DeltaCloudInstanceAdapterFactory.java
===================================================================
--- src/org/jboss/tools/deltacloud/ui/adapter/DeltaCloudInstanceAdapterFactory.java	(revision 29180)
+++ src/org/jboss/tools/deltacloud/ui/adapter/DeltaCloudInstanceAdapterFactory.java	(working copy)
@@ -13,7 +13,7 @@
 import org.eclipse.core.runtime.IAdapterFactory;
 import org.jboss.tools.deltacloud.core.DeltaCloud;
 import org.jboss.tools.deltacloud.core.DeltaCloudInstance;
-import org.jboss.tools.internal.deltacloud.ui.utils.UIUtils;
+import org.jboss.tools.internal.deltacloud.ui.utils.WorkbenchUtils;
 
 public class DeltaCloudInstanceAdapterFactory implements IAdapterFactory {
 
@@ -28,7 +28,7 @@
 		if (adaptableObject instanceof DeltaCloudInstance) {
 			return ((DeltaCloudInstance) adaptableObject).getDeltaCloud();
 		} else {
-			return UIUtils.adapt(adaptableObject, DeltaCloud.class);
+			return WorkbenchUtils.adapt(adaptableObject, DeltaCloud.class);
 		}
 	}
 
Index: src/org/jboss/tools/deltacloud/ui/IDeltaCloudPreferenceConstants.java
===================================================================
--- src/org/jboss/tools/deltacloud/ui/IDeltaCloudPreferenceConstants.java	(revision 29180)
+++ src/org/jboss/tools/deltacloud/ui/IDeltaCloudPreferenceConstants.java	(working copy)
@@ -12,11 +12,19 @@
 
 public interface IDeltaCloudPreferenceConstants {
 	
-	public final static String DONT_CONFIRM_CREATE_INSTANCE = "dont_confirm_create_instance"; //$NON-NLS-1$
-	public final static String AUTO_CONNECT_INSTANCE = "auto_connect_instance"; //$NON-NLS-1$
-	public final static String LAST_EC2_KEYNAME = "last_ec2_keyname"; //$NON-NLS-1$
-	public final static String DEFAULT_KEY_DIR = "default_key_directory"; //$NON-NLS-1$
-	public final static String LAST_CLOUD_INSTANCE_VIEW = "last_cloud_instance_view"; //$NON-NLS-1$
-	public final static String LAST_CLOUD_IMAGE_VIEW = "last_cloud_image_view"; //$NON-NLS-1$
+	public static final String DONT_CONFIRM_CREATE_INSTANCE = "dont_confirm_create_instance"; //$NON-NLS-1$
+	public static final String DONT_CONFIRM_STOP_INSTANCE = "dont_confirm_stop_instance"; //$NON-NLS-1$
+	public static final String AUTO_CONNECT_INSTANCE = "auto_connect_instance"; //$NON-NLS-1$
+	public static final String LAST_EC2_KEYNAME = "last_ec2_keyname"; //$NON-NLS-1$
+	public static final String DEFAULT_KEY_DIR = "default_key_directory"; //$NON-NLS-1$
 
+	public static final String CLOUD_NAME_PROPOSAL_KEY = "cloud_name";//$NON-NLS-1$
+	public static final String CLOUD_USERNAME_PROPOSAL_KEY = "cloud_username";//$NON-NLS-1$
+	public static final String CLOUD_URL_PROPOSAL_KEY = "cloud_url";//$NON-NLS-1$
+	public static final String CLOUD_LAST_INSTANCE_KEY = "last_cloud_instance_view"; //$NON-NLS-1$
+	public static final String CLOUD_LAST_IMAGE_KEY = "last_cloud_image_view"; //$NON-NLS-1$
+
+	public static final String INSTANCE_NAME_PROPOSAL_KEY = "instance_name";//$NON-NLS-1$
+	public static final String INSTANCE_IMAGE_PROPOSAL_KEY = "instance_image";//$NON-NLS-1$
+	public static final String INSTANCE_KEY_PROPOSAL_KEY = "instance_key";//$NON-NLS-1$
 }
